// file : actionMap.h

#ifndef _engine_core_input_action_map_h_
#define _engine_core_input_action_map_h_

namespace Core
{
	namespace Input
	{
		enum eAction
		{
			noneAction,
			escape,
			moveForward,
			moveBackward,
			moveLeft,
			moveRight,
			enableEditor,
			enter,
			select,
			modifier,
			mapSize
		};

		class cActionMap
		{
		public:

			cActionMap()
			{
				map[VK_ESCAPE] = escape;
				map['W'] = moveForward;
				map['S'] = moveBackward;
				map['A'] = moveLeft;
				map['D'] = moveRight;
				map[VK_RETURN] = enter;
				map[VK_F12] = enableEditor;
				map[VK_LBUTTON] = select;
				map[VK_RBUTTON] = modifier;
			}

			std::map<short, short> map;
		};

	}
}
#endif //_engine_core_input_action_map_h_