// file : input.h

#ifndef _engine_core_input_input_h_
#define _engine_core_input_input_h_

#include "actionMap.h"

namespace Core
{
	namespace Input
	{
		enum eKeyState
		{
			released,
			clicked,
			held
		};

		class cInput
		{

		public:
			cInput();

			cActionMap actionMap;
			int action[Input::eAction::mapSize];
			int actionPrevious[Input::eAction::mapSize];
			void remapKey(short key);

			HWND getFocusWindowHandle() { return focusWnd->getHWnd(); }

			void registerFocusWindow(Core::cWindow* _wnd) { focusWnd = _wnd; }
			bool registerDevice(HWND _hwnd, USHORT _usage);
			void unregisterDevice(USHORT _usage);

			void update(float _deltaTime);

			GLfloat mouseXoffset;
			GLfloat mouseYoffset;
			GLfloat mouseZoffset;

			float mouseSensitivity;

		private:
			Core::cWindow* focusWnd;
		};

	} 
}
#endif//_engine_core_input_input_h_