// file : base_state.h

#ifndef _engine_core_states_base_state_h_
#define _engine_core_states_base_state_h_

//#include "../stateManager.h"

namespace Core {
	namespace States {

		// abstract
		class cBase_state
		{
		public:
			cBase_state(void* _manager, std::string _name, glm::vec2 _clientSize)
			{
				pManager   = _manager;
				name       = _name;
				clientSize = _clientSize;
			}

			virtual void initialize() = 0;
			virtual void shutdown() = 0;

			virtual void pause() = 0;
			virtual void resume() = 0;

			virtual void handleEvents() = 0;
			virtual void update(float _deltaTime) = 0;
			virtual void drawText() = 0;
			virtual void draw() = 0;
			// void changeState(cBase_gameState* _state) { manager->changeState(_state); }

			void* pManager;
			std::string name;
			glm::vec2 clientSize;

		protected:
			cBase_state() { /* empty constructor */ }

		};

	}
}

#endif//_engine_core_states_base_state_h_
