// file : menu.cpp

// http://chrismdp.com/2015/06/how-to-quickly-add-bloom-to-your-engine/
// https://www.youtube.com/watch?v=f3Cr8Yx3GGA skinning animation

// https://www.youtube.com/watch?v=AAFkdrP1CHQ&index=1&list=PLmV5I2fxaiCI9IAdFmGChKbIbenqRMi6Z (John Blow) start (menu)
// https://www.youtube.com/watch?v=xfl0jHp1hAM enhanced animation (some other dude)

#include "../../stdafx.h"
#include "menu.h"
#include "../stateManager.h"

using namespace Core::States;


void cMenu::initialize()
{
	debugFont.initialize("verdana.ttf", 9, clientSize);
	menuFont.initialize("Expansiva bold.otf", 48, clientSize);

	rectPlay   = { 320, 390, 480, 432 };
	rectScores = { 190, 310, 610, 352 };
	rectQuit   = { 330, 230, 470, 272 };

	/*
	float vertices_button[] = { // 240 x 60
		-0.15f, 0.05f, 0.0f, 0.0f, 0.0f,
		-0.15f, -0.05f, 0.0f, 0.0f, 0.11719f,
		0.15f, 0.05f, 0.0f, 0.46875f, 0.0f,
		0.15f, -0.05f, 0.0f, 0.46875f, 0.11719f,
	};

	glGenVertexArrays(1, &_vao_button);
	glGenBuffers(1, &_vbo_button);
	glBindVertexArray(_vao_button);
	glBindBuffer(GL_ARRAY_BUFFER, _vbo_button);
	glBufferData(GL_ARRAY_BUFFER, sizeof(vertices_button), vertices_button, GL_STATIC_DRAW);
	glEnableVertexAttribArray(0);
	glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, 5 * sizeof(float), (void*)0);
	glEnableVertexAttribArray(1);
	glVertexAttribPointer(1, 2, GL_FLOAT, GL_FALSE, 5 * sizeof(float), (void*)(3 * sizeof(float)));
	glBindVertexArray(0);

	tex_menu = Graphics::cTexture("Gui/menu.png");
	*/
}


void cMenu::shutdown()
{}

void cMenu::pause()
{}

void cMenu::resume()
{}

void cMenu::handleEvents()
{}


void cMenu::update(float _deltaTime)
{
	static int frameCount = 0;
	++frameCount;

	static float tick = 0.0f;
	tick += _deltaTime;

	sprintf_s(this->deltaTime, "DeltaTime (ms): %.4f\n", _deltaTime*1000.0f);
	if (tick > 1.0f)
	{
		sprintf_s(frameTime, "FPS : %d\n", frameCount);
		tick -= 1.0f;
		frameCount = 0;
	}
}


void cMenu::drawText()
{
	glm::vec3 colorDefault = glm::vec3(1.0, 1.0, 1.0);
	glm::vec3 colorHover = glm::vec3(1.0, 1.0, 0.0);

	POINT cursorPos;
	::GetCursorPos(&cursorPos);
	::ScreenToClient(pCore->input.getFocusWindowHandle(), &cursorPos);
	// convert to bottom left (0, 0)
	cursorPos.y = LONG(clientSize.y - cursorPos.y);

	/*
	debugFont.enableState(pCore->useShader("text"));

	debugFont.setCaretPos(10, 580);
	//debugFont.draw(frameTime);
	debugFont.draw(deltaTime);

	char pos[32];
	sprintf_s(pos, "(%d, %d)\n", cursorPos.x, cursorPos.y);
	debugFont.draw(pos);
	debugFont.disableState();
	*/

	//                                                                                           _
	//  .---  todo : don't like handling user input inside a draw routine...fix me  ----.    \_(O,O)_
	//  V                                                                               V        ~   \


	// ------------------- Game Menu -------------------------
	menuFont.enableState(pCore->useShader("text"));

	// Play --------------------------------------------------
	menuFont.setCaretPos(rectPlay.left, rectPlay.top);
	if (::PtInRect(&rectPlay, cursorPos))
	{
		menuFont.draw("Play", colorHover);
		if (pCore->input.action[Core::Input::eAction::select] == Core::Input::eKeyState::clicked)
			static_cast<Core::cStateManager*>(pManager)->handleEvents(Core::eStateAction::play);		
	}
	else
		menuFont.draw("Play");
	
	// High Scores -------------------------------------------
	menuFont.setCaretPos(rectScores.left, rectScores.top);
	if (::PtInRect(&rectScores, cursorPos))
	{
		menuFont.draw("High Scores", colorHover);
		if (pCore->input.action[Core::Input::eAction::select] == Core::Input::eKeyState::clicked)
			static_cast<Core::cStateManager*>(pManager)->handleEvents(Core::eStateAction::highScore);
	}
	else
		menuFont.draw("High Scores");

	// Quit --------------------------------------------------
	menuFont.setCaretPos(rectQuit.left, rectQuit.top);
	if (::PtInRect(&rectQuit, cursorPos))
	{
		menuFont.draw("Quit", colorHover);
		if (pCore->input.action[Core::Input::eAction::select] == Core::Input::eKeyState::clicked)
		{
			if (MessageBox(nullptr, L"Are you sure you want to quit?", L"Serious?", MB_YESNO) == IDYES)
				PostQuitMessage(0);
		}
	}
	else
		menuFont.draw("Quit");

	menuFont.disableState();
	
}


void cMenu::draw()
{
}
