// file : menuState.h

#ifndef _engine_core_states_menu_h_
#define _engine_core_states_menu_h_

#include "base_state.h"
#include "../../Graphics/Text/font.h"

namespace Core {
	namespace States {

		class cMenu : public cBase_state
		{
		public:
			cMenu(void* _manager, glm::vec2 _clientSize) : cBase_state(_manager, "menu_state", _clientSize) { initialize(); }
			void initialize();
			void shutdown();

			void pause();
			void resume();

			void handleEvents();
			void update(float _deltaTime);
			void drawText();
			void draw();

		private:
			GLuint vao_button;
			GLuint vbo_button;

			Graphics::Text::cFont debugFont;
			Graphics::Text::cFont menuFont;

			char frameTime[32];
			char deltaTime[32];

			RECT rectPlay;
			RECT rectScores;
			RECT rectQuit;
		};

	}
}

#endif//_engine_core_states_menu_h_
