// file : win.h

#ifndef _engine_core_states_win_h_
#define _engine_core_states_win_h_

#include "base_state.h"
#include "../../Graphics/Text/font.h"


namespace Core
{
	namespace States
	{

		class cWin : public cBase_state
		{
		public:
			cWin(void* _manager, glm::vec2 _clientSize) : cBase_state(_manager, "win_state", _clientSize) { initialize(); }
			void initialize();
			void shutdown();

			void pause();
			void resume();

			void handleEvents();
			void update(float _deltaTime);
			void drawText();
			void draw();

			char* winnerName;
			char* winningTime;

		private:
			Graphics::Text::cFont entryFont;
			Graphics::Text::cFont titleFont;
		};

	}
}

#endif//_engine_core_states_win_h_
