// file : core.cpp

#include "../stdafx.h"

namespace Core
{
	cCore* cCore::static_this = nullptr;
}

using namespace Core;

cCore::cCore()
{

}

cCore::~cCore()
{
	while (shaderNames.size() > 0)
		shaderNames.pop_back();
}



void cCore::addShader(std::string _name)
{
	if (shaders.insertProgram(_name) == true)
	{
		shaderNames.push_back(_name);
	}

}


GLuint cCore::useShader(std::string _name)
{
	return shaders.useProgram(_name);
}


void cCore::registerInput(cWindow* _window)
{
	HWND hwnd = _window->getHWnd();
	input.registerDevice(hwnd, 0x06); // keyboard
	input.registerDevice(hwnd, 0x02); // mouse
	input.registerFocusWindow(_window);
}
