// file : core.h

#ifndef _engine_core_core_h_
#define _engine_core_core_h_

#define pCore Core::cCore::getCore()

#include "shaderManager.h"
#include "Input/input.h"


namespace Core
{
	class cCore
	{
	public:
		cCore();
		~cCore();

		Input::cInput input;


		// singleton access
		static cCore* getCore()
		{
			if (static_this == nullptr)
			{
				static_this = new cCore();
			}
			return static_this;
		}


		void shutdown()
		{
			safe_delete(static_this);
		}


		void   addShader(std::string _name);
		GLuint useShader(std::string _name);

		void registerInput(cWindow* _window);


	private:
		std::vector<std::string> shaderNames;
		cShaderManager           shaders;

		static cCore* static_this;
	};
}

#endif//_engine_core_core_h_
