// file : log.h

#ifndef _engine_core_log_h_
#define _engine_core_log_h_

static void Log(const char* _title, const char* _fmt, ...)
{
	std::string msg("");
	if (_fmt != NULL)
	{
		va_list args = NULL;
		va_start(args, _fmt);
		size_t len = _vscprintf(_fmt, args) + 1;

		std::vector<char> buffer(len, '\0');
		int nWritten = vsprintf_s(&buffer[0], len, _fmt, args);

		if (nWritten > 0)
			msg = &buffer[0];

		va_end(args);
	}
	MessageBoxA(nullptr, msg.c_str(), _title, MB_OK);
}

#endif//_engine_core_log_h_
