// file : stateManager.h

#ifndef _engine_core_state_manager_h_
#define _engine_core_state_manager_h_

#include "States/base_state.h"


namespace Core {

	enum eStateAction
	{
		pause,
		play,
		highScore,
		win,
		quit
	};


	class cStateManager
	{
	public:
		void initialize(glm::vec2 _clientSize);
		void shutdown();

		void changeState(States::cBase_state* _state);
		void pushState(States::cBase_state* _state);
		void popState();

		void handleEvents(eStateAction _action);
		void update(float _deltaTime);
		void drawText();
		void draw();

		bool isRunning() { return running; }
		void quit()      { running = false; }


		std::vector<std::shared_ptr<States::cBase_state>> states;

	private:
		bool running;
	};

}
#endif//_engine_core_state_manager_h_
