// file: timer.h

#ifndef _engine_core_timer_h_
#define _engine_core_timer_h_

namespace Core
{

	class cTimer
	{
	public:
		cTimer();

		float getTotalTime() const;
		float getDeltaTime() const;

		void reset();
		void start();
		void stop();
		float tick();

	private:
		double secondsPerCount;
		double deltaTime;

		__int64 baseTime;
		__int64 pausedTime;
		__int64 stopTime;

		__int64 prevTime;
		__int64 thisTime;

		bool stopped;
	};

}

#endif//_engine_core_timer_h_
