// file : window.h

#ifndef _engine_core_window_h_
#define _engine_core_window_h_

#include <vector>

namespace Core
{

	class cWindow
	{
	public:
		cWindow()               {}
		cWindow(const cWindow&) {}
		cWindow(int _width, int _height);
		~cWindow();

		// accessors
		HWND getHWnd()       { return hwnd;                                  }
		HDC getDevice()      { return device;                                }
		glm::vec2 getSize()  { return glm::vec2(clientWidth, clientHeight); }
		RECT getClientRect() { return rectWindow;  }

		std::vector<short> keysActive;
		std::vector<short> keysDeactivate;
		long mouseX, mouseY, mouseZ;

		static LRESULT CALLBACK messageProcedure(HWND _hwnd, UINT _msg, WPARAM _wParam, LPARAM _lParam);

	private:
		HINSTANCE instance;
		HWND      hwnd;
		HDC       device;
		HGLRC     context;

		UINT      clientWidth;
		UINT      clientHeight;
		RECT      rectWindow;
		

		bool initializeWindow();
		bool initializeOpenGL();

	};

}

#endif//_engine_core_window_h_
