// file : font.h

#ifndef _engine_graphics_text_font_h_
#define _engine_graphics_text_font_h_

#include <ft2build.h>
#include FT_FREETYPE_H

namespace Graphics
{
	namespace Text
	{

		struct sCharacter
		{
			GLuint     textureID;
			glm::ivec2 size;
			glm::ivec2 bearing;
			GLuint     advance;
		};


		class cFont
		{
		public:
			unsigned int height;
			GLuint  programID;

			void setCaretPos(int _x, int _y) { origin = cursorPos = glm::vec2(_x, _y); }

			void initialize(std::string _fontName, unsigned int _height, glm::vec2 _screenDims);
			void shutdown();

			void enableState(GLuint _programID);
			void disableState();
			void draw(std::string _text, glm::vec3 _color = glm::vec3(1.0f));

		private:
			std::map<GLchar, sCharacter> characters;
			glm::mat4 projection;
			glm::vec2 cursorPos;
			glm::vec2 origin;

			GLuint vao;
			GLuint vbo;
		};

	}
}

#endif//_engine_graphics_text_font_h_
