// file : mesh.h

#ifndef _engine_graphics_mesh_h_
#define _engine_graphics_mesh_h_

namespace Graphics
{
	static void createArrayObject(float* _vertices, int _numVertices, GLuint& _vao, GLuint& _vbo)
	{
		// 3 float position + 2 float texcoord = 5 floats per vertex
		glGenVertexArrays(1, &_vao);
		glGenBuffers(1, &_vbo);
		glBindVertexArray(_vao);
		glBindBuffer(GL_ARRAY_BUFFER, _vbo);
		glBufferData(GL_ARRAY_BUFFER, sizeof(float) * _numVertices * 5, _vertices, GL_STATIC_DRAW);
		glEnableVertexAttribArray(0);
		glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, 5 * sizeof(float), (void*)0);
		glEnableVertexAttribArray(1);
		glVertexAttribPointer(1, 2, GL_FLOAT, GL_FALSE, 5 * sizeof(float), (void*)(3 * sizeof(float)));
		glBindVertexArray(0);
	}
}

#endif//_engine_graphics_mesh_h_
