// file : texture.h

#ifndef _engine_graphics_texture_h_
#define _engine_graphics_texture_h_


namespace Graphics
{

	class cTexture
	{

	public:

		GLuint _id;


		cTexture()
		{
			_id = 0;
		}

		cTexture(std::string _name)
		{
			int width, height;
			std::string filepath = "Assets/Textures/" + _name;
			unsigned char* image = SOIL_load_image(filepath.c_str(), &width, &height, 0, SOIL_LOAD_RGBA);
			if (image == nullptr) MessageBoxA(0, "Texture failed to load", filepath.c_str(), 0);

			glGenTextures(1, &_id);
			glBindTexture(GL_TEXTURE_2D, _id);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, image);

			glGenerateMipmap(GL_TEXTURE_2D);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);// GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);// GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);


			SOIL_free_image_data(image);
			glBindTexture(GL_TEXTURE_2D, 0);
		}


		void use()
		{
			glBindTexture(GL_TEXTURE_2D, _id);
		}

	};

}
#endif//_engine_graphics_texture_h_
