﻿// file : physics.h

#ifndef _engine_physics_physics_h_
#define _engine_physics_physics_h_

namespace Physics
{
	struct sCircle
	{
		sCircle(glm::vec2 _center, float _radius)
		{
			center = _center;
			radius = _radius;
		}

		glm::vec2 center;
		float radius;
	};


	struct sRectangle
	{
		// axis aligned
		sRectangle(glm::vec2 _center, float _width, float _height)
		{
			center = _center;
			halfWidth = _width / 2.0f;
			halfHeight = _height / 2.0f;
		}

		glm::vec2 center;
		float halfWidth;
		float halfHeight;
	};


	static bool intersectCircleRectangle(sCircle _circle, sRectangle _rect)
	{
		// todo : evaluate when approaching from both sides for correctness...
		// x offset hack in core game call to here...moving on for now. 

		// axis aligned rectangle
		// https://stackoverflow.com/questions/401847/circle-rectangle-collision-detection-intersection
		glm::vec2 circleDistance;
		circleDistance.x = abs(_circle.center.x - _rect.center.x);
		circleDistance.y = abs(_circle.center.y - _rect.center.y);

		if (circleDistance.x > (_rect.halfWidth + _circle.radius))  { return false; }
		if (circleDistance.y > (_rect.halfHeight + _circle.radius)) { return false; }

		if (circleDistance.x <= (_rect.halfWidth))  { return true; }
		if (circleDistance.y <= (_rect.halfHeight)) { return true; }

		float cornerDistance_sq = ((circleDistance.x - _rect.halfWidth)  * (circleDistance.x - _rect.halfWidth)) +
			((circleDistance.y - _rect.halfHeight) * (circleDistance.y - _rect.halfHeight));

		return (cornerDistance_sq <= (_circle.radius * _circle.radius));
	}


	/*
	static bool intersectCirclePolygon(blah blah)
	{
		// different solution stub for arbitrary polygon

		def intersect(Circle(P, R), Rectangle(A, B, C, D)):
		S = Circle(P, R)
		return (pointInRectangle(P, Rectangle(A, B, C, D)) or
		intersectCircle(S, (A, B)) or
		intersectCircle(S, (B, C)) or
		intersectCircle(S, (C, D)) or
		intersectCircle(S, (D, A)))

		0 ≤ AP·AB ≤ AB·AB and 0 ≤ AP·AD ≤ AD·AD // point in Rectangle

		intersectCircle() is easy to implement too:
		one way would be to check if the foot of the perpendicular from P to the line is close enough and between the endpoints,
		and check the endpoints otherwise.
	}
	*/

}
#endif//_engine_physics_physics_h_
