// file : stdafx.h

// openGL loader
#include <gl3w/gl3w.h>

// c++ headers
#include <memory>
#include <iostream>
#include <vector>
#include <algorithm>
#include <functional> // std::function
#include <string>
#include <fstream>
#include <map>
#include <utility> // std::forward, std::move
#include <mutex>

// glm headers (math)
#include <glm-0.9.7.6/glm/glm.hpp>
#include <glm-0.9.7.6/glm/gtc/type_ptr.hpp>
#include <glm-0.9.7.6/glm/gtc/matrix_transform.hpp>
#include <glm-0.9.7.6/glm/gtx/euler_angles.hpp>

// soil headers (texture loading)
#include <soil/SOIL.h>

// application defines
#define safe_delete(x) if(x){ delete x; x = nullptr; }

// application headers
#include "Core/log.h"
#include "Core/window.h"
#include "Core/core.h"
#include "Graphics/texture.h"
#include "Graphics/mesh.h"


// C run time leak detection for visual studio
// https://msdn.microsoft.com/en-us/library/x98tx3cf.aspx
#ifdef _DEBUG
#define _CRTDBG_MAP_ALLOC
#include "crtdbg.h"
#endif



